Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 2528)
@@ -478,11 +500,11 @@
 
          DO jk = 1, jpkm1
-            resto(:,:,jk) = zmrs(:,:) * zhfac(jk) + ( 1. - zmrs(:,:) ) * resto(:,:,jk)
+            presto(:,:,jk) = zmrs(:,:) * zhfac(jk) + ( 1._wp - zmrs(:,:) ) * presto(:,:,jk)
          END DO
 
          ! Mask resto array and set to 0 first and last levels
-         resto(:,:, : ) = resto(:,:,:) * tmask(:,:,:)
-         resto(:,:, 1 ) = 0.e0
-         resto(:,:,jpk) = 0.e0
+         presto(:,:, : ) = presto(:,:,:) * tmask(:,:,:)
+         presto(:,:, 1 ) = 0._wp
+         presto(:,:,jpk) = 0._wp
          !                         !--------------------!
       ELSE                         !     No damping     !
@@ -492,9 +514,12 @@
 
       !                            !--------------------------------!
-      IF( nn_file == 1 ) THEN      !  save damping coef. in a file  !
+      IF( kn_file == 1 ) THEN      !  save damping coef. in a file  !
          !                         !--------------------------------!
          IF(lwp) WRITE(numout,*) '              create damping.coeff.nc file'
-         CALL iom_open  ( 'damping.coeff', inum0, ldwrt = .TRUE., kiolib = jprstlib )
-         CALL iom_rstput( 0, 0, inum0, 'Resto', resto )
+         IF( cdtype == 'TRA' ) cfile = 'damping.coeff'
+         IF( cdtype == 'TRC' ) cfile = 'damping.coeff.trc'
+         cfile = TRIM( cfile )
+         CALL iom_open  ( cfile, inum0, ldwrt = .TRUE., kiolib = jprstlib )
+         CALL iom_rstput( 0, 0, inum0, 'Resto', presto )
          CALL iom_close ( inum0 )
       ENDIF
@@ -549,8 +574,8 @@
            &               '         create the "dist.coast.nc" file using IDL' )
 
-      pdct(:,:,:) = 0.e0
-      zxt(:,:) = cos( rad * gphit(:,:) ) * cos( rad * glamt(:,:) )
-      zyt(:,:) = cos( rad * gphit(:,:) ) * sin( rad * glamt(:,:) )
-      zzt(:,:) = sin( rad * gphit(:,:) )
+      pdct(:,:,:) = 0._wp
+      zxt(:,:) = COS( rad * gphit(:,:) ) * COS( rad * glamt(:,:) )
+      zyt(:,:) = COS( rad * gphit(:,:) ) * SIN( rad * glamt(:,:) )
+      zzt(:,:) = SIN( rad * gphit(:,:) )
 
 
@@ -565,7 +590,7 @@
                zmask(ji,jj) =  ( tmask(ji,jj+1,jk) + tmask(ji+1,jj+1,jk) &
                    &           + tmask(ji,jj  ,jk) + tmask(ji+1,jj  ,jk) )
-               llcotu(ji,jj) = ( tmask(ji,jj,  jk) + tmask(ji+1,jj  ,jk) == 1. ) 
-               llcotv(ji,jj) = ( tmask(ji,jj  ,jk) + tmask(ji  ,jj+1,jk) == 1. ) 
-               llcotf(ji,jj) = ( zmask(ji,jj) > 0. ) .AND. ( zmask(ji,jj) < 4. )
+               llcotu(ji,jj) = ( tmask(ji,jj,  jk) + tmask(ji+1,jj  ,jk) == 1._wp ) 
+               llcotv(ji,jj) = ( tmask(ji,jj  ,jk) + tmask(ji  ,jj+1,jk) == 1._wp ) 
+               llcotf(ji,jj) = ( zmask(ji,jj) > 0._wp ) .AND. ( zmask(ji,jj) < 4._wp )
             END DO
          END DO
@@ -633,5 +658,4 @@
          ! Compute cartesian coordinates of coastline points
          ! and the number of coastline points
-
          icoast = 0
          DO jj = 1, jpj
@@ -659,9 +683,8 @@
 
          ! Distance for the T-points
-
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF( tmask(ji,jj,jk) == 0. ) THEN
-                  pdct(ji,jj,jk) = 0.
+               IF( tmask(ji,jj,jk) == 0._wp ) THEN
+                  pdct(ji,jj,jk) = 0._wp
                ELSE
                   DO jl = 1, icoast
@@ -682,6 +705,6 @@
       ! ----------------------------------------------------------    
       clname = 'dist.coast'
-      itime = 0
-      CALL ymds2ju( 0     , 1      , 1     , 0.e0 , zdate0 )
+      itime  = 0
+      CALL ymds2ju( 0     , 1      , 1     , 0._wp , zdate0 )
       CALL restini( 'NONE', jpi    , jpj   , glamt, gphit ,   &
          &          jpk   , gdept_0, clname, itime, zdate0,   &
@@ -689,5 +712,5 @@
       CALL restput( icot, 'Tcoast', jpi, jpj, jpk, 0, pdct )
       CALL restclo( icot )
-
+      !
    END SUBROUTINE cofdis
 
@@ -701,4 +724,6 @@
       WRITE(*,*) 'tra_dmp: You should not have seen this print! error?', kt
    END SUBROUTINE tra_dmp
+   SUBROUTINE tra_dmp_init        ! Empty routine
+   END SUBROUTINE tra_dmp_init
 #endif
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90	(revision 2528)
@@ -4,11 +4,12 @@
    !! Ocean Active tracers : lateral diffusive trends 
    !!=====================================================================
-   !! History :  9.0  ! 05-11 (G. Madec)  Original code
-   !!----------------------------------------------------------------------
-
-   !!----------------------------------------------------------------------
-   !!   tra_ldf     : update the tracer trend with the lateral diffusion
-   !!       ldf_ctl : initialization, namelist read, and parameters control
-   !!       ldf_ano : compute lateral diffusion for constant T-S profiles
+   !! History :  9.0  ! 2005-11 (G. Madec)  Original code
+   !!       NEMO 3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA 
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   tra_ldf      : update the tracer trend with the lateral diffusion
+   !!   tra_ldf_init : initialization, namelist read, and parameters control
+   !!       ldf_ano  : compute lateral diffusion for constant T-S profiles
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
@@ -20,7 +21,8 @@
    USE traldf_bilap    ! lateral mixing             (tra_ldf_bilap routine)
    USE traldf_iso      ! lateral mixing               (tra_ldf_iso routine)
+   USE traldf_iso_grif ! lateral mixing          (tra_ldf_iso_grif routine)
    USE traldf_lap      ! lateral mixing               (tra_ldf_lap routine)
-   USE trdmod          ! ocean active tracers trends
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce      ! ocean space and time domain
+   USE trdtra          ! ocean active tracers trends
    USE prtctl          ! Print control
    USE in_out_manager  ! I/O manager
@@ -31,11 +33,10 @@
    PRIVATE
 
-   PUBLIC   tra_ldf    ! called by step.F90 
-
-   INTEGER, PUBLIC ::   nldf = 0   ! type of lateral diffusion used defined from ln_traldf_... namlist logicals)
-                                   ! (need to be public to be used in vertical diffusion routine)
+   PUBLIC   tra_ldf         ! called by step.F90 
+   PUBLIC   tra_ldf_init    ! called by opa.F90 
+   !
+   INTEGER ::   nldf = 0   ! type of lateral diffusion used defined from ln_traldf_... namlist logicals)
 #if defined key_traldf_ano
-   REAL, DIMENSION(jpi,jpj,jpk) ::   t0_ldf, s0_ldf   ! lateral diffusion trends of T & S
-      !                                               ! for a constant vertical profile
+   REAL, DIMENSION(jpi,jpj,jpk) ::   t0_ldf, s0_ldf   ! lateral diffusion trends of T & S for a constant profile
 #endif
 
@@ -44,9 +45,8 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -56,58 +56,67 @@
       !! 
       !! ** Purpose :   compute the lateral ocean tracer physics.
-      !!
       !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdt, ztrds   ! 3D temporary workspace
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000 )   CALL ldf_ctl          ! initialisation & control of options
-
-      IF( l_trdtra )   THEN                      ! temporary save of ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:) 
-         ztrds(:,:,:) = sa(:,:,:) 
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
+      !!----------------------------------------------------------------------
+
+      IF( l_trdtra )   THEN                    !* Save ta and sa trends
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem) 
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
       ENDIF
 
       SELECT CASE ( nldf )                       ! compute lateral mixing trend and add it to the general trend
-      CASE ( 0 )   ;   CALL tra_ldf_lap   ( kt )      ! iso-level laplacian
-      CASE ( 1 )   ;   CALL tra_ldf_iso   ( kt )      ! rotated laplacian (except dk[ dk[.] ] part)
-      CASE ( 2 )   ;   CALL tra_ldf_bilap ( kt )      ! iso-level bilaplacian
-      CASE ( 3 )   ;   CALL tra_ldf_bilapg( kt )      ! s-coord. horizontal bilaplacian
+      CASE ( 0 )   ;   CALL tra_ldf_lap     ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts        )  ! iso-level laplacian
+      CASE ( 1 )                                                                              ! rotated laplacian
+         IF( ln_traldf_grif ) THEN                                                          
+                       CALL tra_ldf_iso_grif( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts, ahtb0 )      ! Griffies operator
+         ELSE                                                                                
+                       CALL tra_ldf_iso     ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts, ahtb0 )      ! Madec operator
+         ENDIF
+      CASE ( 2 )   ;   CALL tra_ldf_bilap   ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts        )  ! iso-level bilaplacian
+      CASE ( 3 )   ;   CALL tra_ldf_bilapg  ( kt, 'TRA',             tsb, tsa, jpts        )  ! s-coord. geopot. bilap.
          !
-      CASE ( -1 )                                     ! esopa: test all possibility with control print
-         CALL tra_ldf_lap    ( kt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf0 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_ldf_iso    ( kt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf1 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_ldf_bilap  ( kt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf2 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_ldf_bilapg ( kt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf3 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      CASE ( -1 )                                ! esopa: test all possibility with control print
+         CALL tra_ldf_lap   ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts        ) 
+         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf0 - Ta: ', mask1=tmask,               &
+         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         IF( ln_traldf_grif ) THEN
+            CALL tra_ldf_iso_grif( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts, ahtb0 )
+         ELSE
+            CALL tra_ldf_iso     ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts, ahtb0 )  
+         ENDIF
+         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf1 - Ta: ', mask1=tmask,               &
+         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         CALL tra_ldf_bilap ( kt, 'TRA', gtsu, gtsv, tsb, tsa, jpts        ) 
+         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf2 - Ta: ', mask1=tmask,               &
+         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         CALL tra_ldf_bilapg( kt, 'TRA',             tsb, tsa, jpts        ) 
+         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf3 - Ta: ', mask1=tmask,               &
+         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       END SELECT
 
 #if defined key_traldf_ano
-      ta(:,:,:) = ta(:,:,:) - t0_ldf(:,:,:)      ! anomaly: substract the reference diffusivity
-      sa(:,:,:) = sa(:,:,:) - s0_ldf(:,:,:)
+      tsa(:,:,:,jp_tem) = tsa(:,:,:,jp_tem) - t0_ldf(:,:,:)      ! anomaly: substract the reference diffusivity
+      tsa(:,:,:,jp_sal) = tsa(:,:,:,jp_sal) - s0_ldf(:,:,:)
 #endif
+
       IF( l_trdtra )   THEN                      ! save the horizontal diffusive trends for further diagnostics
-         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_ldf, 'TRA', kt )
+         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+         ztrds(:,:,:) = tsa(:,:,:,jp_sal) - ztrds(:,:,:)
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_ldf, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_ldf, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds ) 
       ENDIF
       !                                          ! print mean trends (used for debugging)
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf  - Ta: ', mask1=tmask,               &
-         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf  - Ta: ', mask1=tmask,               &
+         &                       tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       !
    END SUBROUTINE tra_ldf
 
 
-   SUBROUTINE ldf_ctl
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE ldf_ctl  ***
+   SUBROUTINE tra_ldf_init
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_ldf_init  ***
       !! 
       !! ** Purpose :   Choice of the operator for the lateral tracer diffusion
@@ -122,7 +131,4 @@
       INTEGER ::   ioptio, ierr         ! temporary integers 
 !      
-!     NAMELIST/namtra_ldf/ ln_traldf_lap  , ln_traldf_bilap,                  &
-!        &                 ln_traldf_level, ln_traldf_hor  , ln_traldf_iso,   &
-!        &                 rn_aht_0       , rn_ahtb_0      , rn_aeiv_0
       !!----------------------------------------------------------------------
 
@@ -130,17 +136,11 @@
       ! ===============================================
     
-!     REWIND( numnam )                ! Namelist namtra_ldf already read in ldftra module
-!     READ  ( numnam, namtra_ldf )    
-
       IF(lwp) THEN                    ! Namelist print
          WRITE(numout,*)
-         WRITE(numout,*) 'tra:ldf_ctl : lateral tracer diffusive operator'
+         WRITE(numout,*) 'tra_ldf_init : lateral tracer diffusive operator'
          WRITE(numout,*) '~~~~~~~~~~~'
-         WRITE(numout,*) '   Namelist namtra_ldf : set lateral mixing parameters (type, direction, coefficients)'
-         WRITE(numout,*) '      laplacian operator          ln_traldf_lap   = ', ln_traldf_lap
-         WRITE(numout,*) '      bilaplacian operator        ln_traldf_bilap = ', ln_traldf_bilap
-         WRITE(numout,*) '      iso-level                   ln_traldf_level = ', ln_traldf_level
-         WRITE(numout,*) '      horizontal (geopotential)   ln_traldf_hor   = ', ln_traldf_hor
-         WRITE(numout,*) '      iso-neutral                 ln_traldf_iso   = ', ln_traldf_iso
+         WRITE(numout,*) '   Namelist namtra_ldf already read in ldftra module'
+         WRITE(numout,*) '   see ldf_tra_init report for lateral mixing parameters'
+         WRITE(numout,*)
       ENDIF
 
@@ -225,5 +225,5 @@
       CALL ldf_ano
       !
-   END SUBROUTINE ldf_ctl
+   END SUBROUTINE tra_ldf_init
 
 #if defined key_traldf_ano
@@ -271,16 +271,16 @@
       t0_ldf(:,:,:) = 0.e0
       s0_ldf(:,:,:) = 0.e0
-      ztb   (:,:,:) = tb (:,:,:)
-      zsb   (:,:,:) = sb (:,:,:)
-      ua    (:,:,:) = ta (:,:,:)
-      va    (:,:,:) = sa (:,:,:)
+      ztb   (:,:,:) = tsb (:,:,:,jp_tem)
+      zsb   (:,:,:) = tsb (:,:,:,jp_sal)
+      ua    (:,:,:) = tsa (:,:,:,jp_tem)
+      va    (:,:,:) = tsa (:,:,:,jp_sal)
       zavt  (:,:,:) = avt(:,:,:)
       IF( lk_zdfddm ) THEN CALL ctl_stop( ' key_traldf_ano with key_zdfddm not implemented' )
       ! set tb, sb to reference values and avr to zero
-      tb (:,:,:) = zt_ref(:,:,:)
-      sb (:,:,:) = zs_ref(:,:,:)
-      ta (:,:,:) = 0.e0
-      sa (:,:,:) = 0.e0
-      avt(:,:,:) = 0.e0
+      tsb (:,:,:,jp_tem) = zt_ref(:,:,:)
+      tsb (:,:,:,jp_sal) = zs_ref(:,:,:)
+      tsa (:,:,:,jp_tem) = 0.e0
+      tsa (:,:,:,jp_sal) = 0.e0
+      avt(:,:,:)         = 0.e0
 
       ! Compute the ldf trends
@@ -295,17 +295,17 @@
       IF( neuler == 1)   z12 = 1.e0
       IF( ln_zdfexp ) THEN      ! ta,sa are the trends
-         t0_ldf(:,:,:) = ta(:,:,:)
-         s0_ldf(:,:,:) = sa(:,:,:)
+         t0_ldf(:,:,:) = tsa(:,:,:,jp_tem)
+         s0_ldf(:,:,:) = tsa(:,:,:,jp_sal)
       ELSE
          DO jk = 1, jpkm1
-            t0_ldf(:,:,jk) = ( ta(:,:,jk) - tb(:,:,jk) ) / ( z12 *rdttra(jk) )
-            s0_ldf(:,:,jk) = ( sa(:,:,jk) - tb(:,:,jk) ) / ( z12 *rdttra(jk) )
+            t0_ldf(:,:,jk) = ( tsa(:,:,jk,jp_tem) - tsb(:,:,jk,jp_tem) ) / ( z12 *rdttra(jk) )
+            s0_ldf(:,:,jk) = ( tsa(:,:,jk,jp_sal) - tsb(:,:,jk,jp_sal) ) / ( z12 *rdttra(jk) )
          END DO
       ENDIF
-      tb    (:,:,:) = ztb (:,:,:)
-      sb    (:,:,:) = zsb (:,:,:)
-      ta    (:,:,:) = ua  (:,:,:)
-      sa    (:,:,:) = va  (:,:,:)
-      avt   (:,:,:) = zavt(:,:,:)
+      tsb(:,:,:,jp_tem) = ztb (:,:,:)
+      tsb(:,:,:,jp_sal) = zsb (:,:,:)
+      tsa(:,:,:,jp_tem) = ua  (:,:,:)
+      tsa(:,:,:,jp_sal) = va  (:,:,:)
+      avt(:,:,:)        = zavt(:,:,:)
       !
    END SUBROUTINE ldf_ano
